

local function print(x)
	if(type(x)=="table") then
		for k,v in pairs(x) do
			ChatFrame1:AddMessage(k.." = "..tostring(v))
		end
	else
		ChatFrame1:AddMessage(x)
	end
end

local Options =
{

	mob = {
		level 									= 73,
		hit 										= 0,  -- plus hit for your attacker
		mitigation 							= .9,
		dodge										= 1,
		parry										= 1,
		block										= 1,
	},

	fbEnergy 								= 0,
	shredBonus 							= 0,--81, -- idol
	catMangleBonus					= 23, -- idol

	swipeBonus							= 0,
	maulBonus								= 0,
	bearMangleBonus					= 0,


	-- todo add code to detect these values
	preditoryInstinctsRank	= 5,
	survivalOfTheFittest		= 3,
	thickHide 							= 3,
  hpPerSta 								= 10.5,
	bloodFrenzy							= true,
	heartOfTheWild					= 5,
	playerLevel 						= 70,

}


local function BareID(itemString)

	if(itemString) then
		local prefix,itemId,_,_,_,_,_,suffixId,uniqueId = strsplit(":", itemString)

		return strjoin(":", prefix, itemId, 0, 0, 0, 0, 0, suffixId, uniqueId)
	end
	return itemString
end


local AGI_TO_DODGE 					= 14.709
local AGI_TO_CRIT 					= 25
local CR_DODGE_PERCENT 			= 18.92
local CR_DEFENSE_TO_SKILL 	= 2.4
local CR_RESILIENCE_PERCENT	= 39.4
local CR_CRIT_PERCENT 			= 22.08
local CR_HIT_PERCENT 				= 15.76
local CR_HASTE_PERCENT 			= 15.76
local CR_WEAPON_TO_SKILL 		= 3.9 

CatPoints = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceHook-2.1")


function CatPoints:Bonuses(bonuses, stats, form)
	--print(bonuses)

	local sotf = (1+stats.survivalOfTheFittest*.01)
	local t = {}
	t.__index = t
	setmetatable(t, stats)


	local armorMultiplier = 1
	local healthMultiplier = 1
	local strMultiplier = 1
	local staMultiplier = 1
	local apPerAgi = 0
	if(form == "Bear") then
		armorMultiplier = 5.0*(1 + 0.1*stats.thickHide/3)
		staMultiplier = 1.25*(1 + .2*stats.heartOfTheWild/5)

		bonuses.STA = bonuses.STA + bonuses.EMPTY_META_SOCKET*18
		bonuses.STA = bonuses.STA + bonuses.EMPTY_BLUE_SOCKET*6
		bonuses.STA = bonuses.STA + bonuses.EMPTY_RED_SOCKET*6
		bonuses.STA = bonuses.STA + bonuses.EMPTY_YELLOW_SOCKET*6


		bonuses.STA = bonuses.STA + bonuses.EMPTY_BLUE_SOCKET*4
		bonuses.STA = bonuses.STA + bonuses.EMPTY_RED_SOCKET*4
		bonuses.STA = bonuses.STA + bonuses.EMPTY_YELLOW_SOCKET*4

	elseif(form == "Cat") then
		armorMultiplier = 1.1*stats.thickHide/3
		strMultiplier = 1 + .2*stats.heartOfTheWild/5
		apPerAgi = 1

		bonuses.AGI = bonuses.AGI+bonuses.EMPTY_META_SOCKET*12
		bonuses.CR_CRIT = bonuses.CR_CRIT+bonuses.EMPTY_META_SOCKET*3

		bonuses.AGI = bonuses.AGI+bonuses.EMPTY_RED_SOCKET*8+bonuses.EMPTY_BLUE_SOCKET*4



		bonuses.STR = bonuses.STR+bonuses.EMPTY_YELLOW_SOCKET*4
		bonuses.CR_CRIT = bonuses.CR_CRIT+bonuses.EMPTY_YELLOW_SOCKET*4


	end

	bonuses.AGI = bonuses.AGI*sotf
	bonuses.STA = bonuses.STA*sotf*staMultiplier
	bonuses.STR = bonuses.STR*sotf*strMultiplier;

	local ap = bonuses.ATTACKPOWER+bonuses.ATTACKPOWERFERAL+2*bonuses.STR+apPerAgi*bonuses.AGI
	
	t.armor = stats.armor+bonuses.ARMOR*armorMultiplier+2*bonuses.AGI

	t.dodge = stats.dodge + bonuses.AGI/AGI_TO_DODGE + bonuses.CR_DODGE/CR_DODGE_PERCENT

	t.health = stats.health + bonuses.STA*stats.hpPerSta+bonuses.HEALTH

	t.defense = stats.defense + bonuses.CR_DEFENSE/CR_DEFENSE_TO_SKILL

	t.resilience = stats.resilience + bonuses.CR_RESILIENCE

	t.ap = stats.ap + ap
	t.baseDamage = stats.baseDamage + ap/14*1.1 + bonuses.MELEEDMG

	t.weaponSkill = stats.weaponSkill + bonuses.CR_WEAPON_FERAL/CR_WEAPON_TO_SKILL

	t.crit = stats.crit +bonuses.CR_CRIT/CR_CRIT_PERCENT+bonuses.AGI/AGI_TO_CRIT

	t.hit = stats.hit+bonuses.CR_HIT/CR_HIT_PERCENT

	t.haste = (stats.haste+bonuses.CR_HASTE/CR_HASTE_PERCENT)/100

	t.ARCANERES = stats.ARCANERES+bonuses.ARCANERES+bonuses.ALL_RESISTS
	t.HOLYRES = stats.HOLYRES+bonuses.HOLYRES+bonuses.ALL_RESISTS
	t.FIRERES = stats.FIRERES+bonuses.FIRERES+bonuses.ALL_RESISTS
	t.FROSTRES = stats.FROSTRES+bonuses.FROSTRES+bonuses.ALL_RESISTS
	t.NATURERES = stats.NATURERES+bonuses.NATURERES+bonuses.ALL_RESISTS
	t.SHADOWRES = stats.SHADOWRES+bonuses.SHADOWRES+bonuses.ALL_RESISTS

	return t
end


function CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, form)

	local bonuses = {
		STR 							= 0,
		AGI 							= 0,
		STA 							= 0,
		ARMOR 				= 0,
		CR_DODGE 					= 0,
		HEALTH 						= 0,
		CR_DEFENSE 				= 0,
		CR_RESILIENCE 		= 0,
		ATTACKPOWER 			= 0,
		ATTACKPOWERFERAL	= 0,
		CR_WEAPON_FERAL 	= 0,
		CR_HIT 						= 0,
		CR_HASTE 					= 0,
		CR_CRIT 					= 0,

		EMPTY_RED_SOCKET 				= 0,
		EMPTY_YELLOW_SOCKET 		= 0,
		EMPTY_BLUE_SOCKET 			= 0,
		EMPTY_META_SOCKET 			= 0,

		MELEEDMG					= 0,


		ARCANERES					= 0,
		FIRERES						= 0,
		FROSTRES					= 0,
		HOLYRES						= 0,
		SHADOWRES					= 0,
		NATURERES					= 0,
		ALL_RESISTS				= 0,
	}

	for k in pairs(bonuses) do
		bonuses[k] = (itemBonuses[k] or 0) - (equippedBonuses[k] or 0)
	end

	return self:Bonuses(bonuses, stats, form)

end

-- Data
INVTYPE_WEAPON_OTHER = INVTYPE_WEAPON.."_other";
INVTYPE_FINGER_OTHER = INVTYPE_FINGER.."_other";
INVTYPE_TRINKET_OTHER = INVTYPE_TRINKET.."_other";

EquipCompare_ItemTypes = {
	["INVTYPE_2HWEAPON"] = "MainHandSlot", -- Two-Hand
	["INVTYPE_BODY"] = "ShirtSlot", -- Shirt
	["INVTYPE_CHEST"] = "ChestSlot", -- Chest
	["INVTYPE_CLOAK"] = "BackSlot", -- Back
	["INVTYPE_FEET"] = "FeetSlot", -- Feet
	["INVTYPE_FINGER"] = "Finger0Slot", -- Finger
	["INVTYPE_FINGER_OTHER"] = "Finger1Slot", -- Finger_other
	["INVTYPE_HAND"] = "HandsSlot", -- Hands
	["INVTYPE_HEAD"] = "HeadSlot", -- Head
	["INVTYPE_HOLDABLE"] = "SecondaryHandSlot", -- Held In Off-hand
	["INVTYPE_LEGS"] = "LegsSlot", -- Legs
	["INVTYPE_NECK"] = "NeckSlot", -- Neck
	["INVTYPE_RANGED"] = "RangedSlot", -- Ranged
	["INVTYPE_RELIC"] = "RangedSlot", -- Relic
	["INVTYPE_ROBE"] = "ChestSlot", -- Chest
	["INVTYPE_SHIELD"] = "SecondaryHandSlot", -- Off Hand
	["INVTYPE_SHOULDER"] = "ShoulderSlot", -- Shoulder
	["INVTYPE_TABARD"] = "TabardSlot", -- Tabard
	["INVTYPE_TRINKET"] = "Trinket0Slot", -- Trinket
	["INVTYPE_TRINKET_OTHER"] = "Trinket1Slot", -- Trinket_other
	["INVTYPE_WAIST"] = "WaistSlot", -- Waist
	["INVTYPE_WEAPON"] = "MainHandSlot", -- One-Hand
	["INVTYPE_WEAPON_OTHER"] = "SecondaryHandSlot", -- One-Hand_other
	["INVTYPE_WEAPONMAINHAND"] = "MainHandSlot", -- Main Hand
	["INVTYPE_WEAPONOFFHAND"] = "SecondaryHandSlot", -- Off Hand
	["INVTYPE_WRIST"] = "WristSlot", -- Wrist
	["INVTYPE_WAND"] = "RangedSlot", -- Wand

	-- Inventory types not defined in GlobalStrings.lua
	["INVTYPE_GUN"] = "RangedSlot", -- Gun
	["INVTYPE_GUNPROJECTILE"] = "AmmoSlot", -- Projectile
	["INVTYPE_BOWPROJECTILE"] = "AmmoSlot", -- Projectile
	["INVTYPE_CROSSBOW"] = "RangedSlot", -- Crossbow
	["INVTYPE_THROWN"] = "RangedSlot", -- Thrown
};
local bonus = AceLibrary("ItemBonusLib-1.0")





local function HitPercent()
	return (GetCombatRating(CR_HIT_MELEE))/CR_HIT_PERCENT
end


local function CritPercent()
	return GetCritChance()
end

local function Health()
	return UnitHealthMax("player")
end

local function HastePercent()
	return (GetCombatRating(CR_HASTE_MELEE))/CR_HASTE_PERCENT
end


local function WeaponSkill()
	return (GetCombatRating(CR_WEAPON_SKILL))/CR_WEAPON_TO_SKILL
end

local function AttackPower()
	local base, posBuff, negBuff = UnitAttackPower("player")
	return base+posBuff+negBuff
end


-- returns paper doll dps
local function BaseDPS()
	local attackSpeed = UnitAttackSpeed("player");

	local lowDmg, hiDmg, _, _, _, _, percentmod = UnitDamage("player")
	return (hiDmg+lowDmg)/(2*attackSpeed)
end


-- returns the number of moves to get 5cp
local function CalcMoves(critChance, missChance, bloodFrenzy)

	local hitChance = 1-missChance
	if(critChance == 0 or not bloodFrenzy) then
		return 5/hitChance
	end

	local effectiveCritChance = critChance/(hitChance)

	return (5-4*effectiveCritChance+3*effectiveCritChance^2-2*effectiveCritChance^3+effectiveCritChance^4)/hitChance
end


local Moves =
{
	Shred = {
		damage = function(stats, mangled)
			return (stats.baseDamage*2.25  + 405 + (stats.shredBonus or 0))*((mangled and 1.3) or 1)*(stats.mitigation or 1)
		end,
		energy = 4.2, -- talented
	},
	Rip = {
		damage = function(stats, mangled)
			return (1-stats.missChance)*(stats.ap*.24+1092)*((mangled and 1.3) or 1)
		end,
		energy = 3,
	},
--------------------------------------------------------------------------------
-- 	Pounce = {
-- 		damage = function(stats, mangled)
-- 			return (1-stats.missChance)(600+.18*stats.ap)*((mangled and 1.3) or 1)
-- 		end,
-- 		energy = 5
-- 	},
-- 	Mangle = {
-- 		damage = function(stats)
-- 			return stats.damageMultiplier*(stats.baseDamage*1.6+stats.mangleDamage+(stats.mangleBonus or 0))*stats.savageFuryMultiplier*(stats.mitigation or 1)
-- 		end,
-- 		energy = 4 -- talented
-- 	},
-- 	Rake = {
-- 		damage = function(stats, mangled)
-- 			local mangle = ((mangled and 1.3) or 1)
-- 			return stats.damageMultiplier*(stats.ap*.01+78)*(mangle)*stats.savageFuryMultiplier+
-- 				(108+stats.ap*.06)*mangle*(1-stats.missChance)
-- 		end,
-- 		energy = 2.5 -- talented
-- 	},
-- 	Ravage = {
-- 		damage = function(stats)
-- 			return stats.damageMultiplier*(stats.baseDamage*3.5+514)*stats.mitigation
-- 		end,
-- 		energy = 6
-- 	}
--------------------------------------------------------------------------------
}


local Combo =
{
	["Shreds + Rip, sustained"] = {
		moves={"Shred", "Shred", "Shred", "Shred", "Shred", "Rip"},
		behind = true,
		sustained = true,
		mangled = true,
		time = function(self, nonMisses, missChance, totalMissTime)
			local energy = Moves[self.moves[1]].energy
			local finisherEnergy = Moves[self.moves[#self.moves]].energy
			return energy*nonMisses + finisherEnergy/(1-missChance)-((self.sustained and 0) or 10)+totalMissTime
		end,
		damage = function(self, stats)
			local comboTime = self:time(stats.nonMisses, stats.missChance, stats.totalMissTime)

			local cpDPS = stats.comboDamage*Moves[self.moves[1]].damage(stats, self.mangled)/comboTime
			local finisherDamage = Moves[self.moves[#self.moves]].damage(stats, self.mangled)/comboTime
			return cpDPS, finisherDamage
		end
	}
}


local function CalcCatDPS(config)

	local missRate = 0

	local defenseDifference = config.mob.level*5-350-config.weaponSkill
	
	if(defenseDifference <= 10) then
		missRate = 5 + defenseDifference*.1
	else
		missRate = 7 + (defenseDifference-10)*.4
	end


	
	local hit 	= config.hit
	local miss 	= missRate
	local dodge = config.mob.dodge*missRate
	local block = config.mob.block*missRate
	local parry = config.mob.parry*missRate
	
	miss  = (miss  < 0 and 0) or miss
	dodge = (dodge < 0 and 0) or dodge
	block = (block < 0 and 0) or block
	parry = (parry < 0 and 0) or parry
	
	hit = (hit > miss and miss) or hit

	local critChance = config.crit/100
	local baseMissChance = (miss+dodge-hit)/100
	local frontMissChance = (block+parry-hit)/100
	local combo											= Combo[config.combo]
	local missChance								= baseMissChance
	local critChance 								= config.crit/100
	if(not (combo.behind or config.behind)) then
		missChance = missChance+frontMissChance
	end
	local comboMoves 								= CalcMoves(critChance, missChance, config.bloodFrenzy)
	local missCount 								= comboMoves * missChance
	local critCount 								= comboMoves * critChance
	local hitCount									= comboMoves - critCount - missCount

	local stats =
	{
		nonMisses					= comboMoves - missCount,
		missChance				= missChance,
		totalMissTime			= missCount*1.5,
		comboDamage 			= critCount * (1+(1 + .3 *config.preditoryInstinctsRank/5))+hitCount,
		damageMultiplier	= 1+ critChance * (1 + .3 *config.preditoryInstinctsRank/5) - missChance
	}
	setmetatable(stats,config)



	local cpDamage, finisherDamage	= combo:damage(stats)

	local dps = config.baseDamage*stats.damageMultiplier*(1+config.haste)+cpDamage+finisherDamage

	return dps
end

local function CalculateArmorMitigation(stats)
	local armorMitigation = 1-( stats.armor / (stats.armor -22167.5+467.5*stats.mob.level))
	if(armorMitigation < .25) then
		armorMitigation = .25
	end
	return armorMitigation
end

local function CalculateMagicMitigation(stats, school)
	local magicMitigation = 1-( ((stats[school] or 0)) / (5*stats.mob.level) *.75)
	if(magicMitigation < .25) then
		magicMitigation = .25
	end
	return magicMitigation
end

local function EffectiveHealthMagic(stats, school)
	--print(stats.health/CalculateMagicMitigation(stats, school))
	return stats.health/CalculateMagicMitigation(stats, school)
end

local function EffectiveHealth(stats)
	return stats.health/CalculateArmorMitigation(stats)
end

local function CalcTP(stats)
	local defenseEffect = (stats.defense - stats.mob.level *5)*.04

	local attackTable = {
		miss = 5+defenseEffect+(stats.hitAvoidance or 0)- stats.mob.hit,
		dodge = stats.dodge+defenseEffect,
		--no parry
		--no glancing blow
		--no block
		crit = (5 + (stats.mob.level - stats.playerLevel)*.2 - stats.survivalOfTheFittest -
		 stats.resilience/CR_RESILIENCE_PERCENT) - defenseEffect,
		crushing = (stats.mob.level-stats.playerLevel) * 5,
	}
	-- not likely without shield block, but hey
	if(attackTable.miss+attackTable.crit+attackTable.crushing > 100) then
		attackTable.crushing = 100 - (attackTable.miss+attackTable.crit)
	end

	for k,v in pairs(attackTable) do
		if(v < 0) then
			attackTable[k]=0
		else
			attackTable[k]=v*.01
		end
	end

	local mobDamage = 1 - attackTable.miss - attackTable.dodge + attackTable.crit*(1-2*stats.resilience/CR_RESILIENCE_PERCENT)+.5*attackTable.crushing


	mobDamage = mobDamage*CalculateArmorMitigation(stats)
	return stats.health/mobDamage
end


local function CalcBearDPS(config)

	local missRate = 0

	local defenseDifference = config.mob.level*5-350-config.weaponSkill
	
	if(defenseDifference <= 10) then
		missRate = 5 + defenseDifference*.1
	else
		missRate = 7 + (defenseDifference-10)*.4
	end


	
	local hit 	= config.hit
	local miss 	= missRate
	local dodge = config.mob.dodge*missRate
	local block = config.mob.block*missRate
	local parry = config.mob.parry*missRate
	
	miss  = (miss  < 0 and 0) or miss
	dodge = (dodge < 0 and 0) or dodge
	block = (block < 0 and 0) or block
	parry = (parry < 0 and 0) or parry
	
	hit = (hit > miss and miss) or hit
	
	local critChance = config.crit/100

	local missChance = (miss+dodge+block+parry-hit)/100

	local damageMultiplier = 1 + (critChance*(1+.03*config.preditoryInstinctsRank/5)) - missChance

	local maulDPS = ((config.baseDamage + 176+config.maulBonus) / 3.2)*(1+ config.haste)
	local swipeDPS = config.swipeBonus+83+.07*config.ap
	local lacerateDPS = 5*31/3*1.3
	local mangleDPS = (1.15*config.baseDamage+264)/6
	local autoAttack = config.baseDamage*(1+ config.haste)

	return (swipeDPS+mangleDPS+autoAttack+maulDPS)*damageMultiplier + lacerateDPS--*(1-missChance)
end


local function GetStats(form)
	CurrentForm = function() return form end
	local baseDefense, armorDefense = UnitDefense("player")
	local _, armor=UnitArmor("player")

	local stats = {
		baseDamage 							= BaseDPS(),
		ap 											= AttackPower(),
		combo										= "Shreds + Rip, sustained",
		crit										= CritPercent(),
		hit											= HitPercent(),
		haste										= HastePercent(),
		weaponSkill							= WeaponSkill(),
		defense 								= baseDefense+ armorDefense,
		hitAvoidance 						= GetCombatRating(CR_HIT_TAKEN_MELEE),
		dodge 									= GetDodgeChance(),
		resilience 							= GetCombatRating(CR_CRIT_TAKEN_MELEE),
		armor 									= armor,
		health 									= Health(),
		ARCANERES								= UnitResistance("player", 6),
		FIRERES									= UnitResistance("player", 2),
		FROSTRES								= UnitResistance("player", 4),
		HOLYRES									= UnitResistance("player", 1),
		SHADOWRES								= UnitResistance("player", 5),
		NATURERES								= UnitResistance("player", 3),
		ALL_RESISTS							= 0,
	}


	stats.__index = stats
	setmetatable(stats, Options)


	return stats
end


local function Equivalence(form)
	local stats = GetStats(form)
	local allbonus =
	{
		ATTACKPOWER				= 0,
		AGI 							= 0,
		
		STR								= 0,
		ATTACKPOWERFERAL	= 0,
		CR_HASTE					= 0,
		
		STA 							= 0,
		ARMOR 						= 0,
		CR_DODGE 					= 0,
		HEALTH 						= 0,
		CR_DEFENSE 				= 0,
		CR_RESILIENCE			= 0,
		CR_WEAPON_FERAL		= 0,
		CR_HIT						= 0,
		CR_CRIT						= 0,
		ARCANERES					= 0,
		FIRERES						= 0,
		FROSTRES					= 0,
		HOLYRES						= 0,
		SHADOWRES					= 0,
		NATURERES					= 0,
		ALL_RESISTS				= 0, 
		
		EMPTY_RED_SOCKET 	= 0,
		EMPTY_YELLOW_SOCKET= 0,
		EMPTY_BLUE_SOCKET 			= 0,
		EMPTY_META_SOCKET 			= 0,

		MELEEDMG					= 0,
	}

	local accum = {}

	local base =
	{
		baseCat = CalcCatDPS(stats),
		baseBear = CalcBearDPS(stats),
	 	baseTP = CalcTP(stats),
	}

	local summary = {}
	for k in pairs(allbonus) do
		local tmp = {}
		tmp[k]=1
		local dps = CalcCatDPS(CatPoints:CalculateStatChanges(stats, {}, tmp, "Cat") )- base.baseCat
		if(dps ~= 0) then
			summary[k]= dps
		end
	end
	
	
	local compareTo = summary.ATTACKPOWER
	if(compareTo <= 0) then
		compareTo = summary.ARMOR
	end
	
	if(compareTo <= 0) then
		compareTo = summary.STA
	end

	for k in pairs(summary) do
		summary[k] = summary[k]/compareTo
		print(format("%.2f  %s", summary[k], k))
	end

end





local Modifiers = {
	CatDPS = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Cat")
			return (CalcCatDPS(t)-CalcCatDPS(stats))
		end,
	},
	CatMTG = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Cat")
			return (CalcTP(t)-CalcTP(stats))/10
		end,
	},
	BearH = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Bear")
			return (EffectiveHealth(t)-EffectiveHealth(stats))/10
		end,
	},
	BearArcane = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Bear")
			return (EffectiveHealthMagic(t, "ARCANERES")-EffectiveHealthMagic(stats, "ARCANERES"))/10
		end,
	},
	BearFire = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Bear")
			return (EffectiveHealthMagic(t, "FIRERES")-EffectiveHealthMagic(stats, "FIRERES"))/10
		end,
	},
	BearNature = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Bear")
			return (EffectiveHealthMagic(t, "NATURERES")-EffectiveHealthMagic(stats, "NATURERES"))/10
		end,
	},
	BearShadow = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Bear")
			return (EffectiveHealthMagic(t, "SHADOWRES")-EffectiveHealthMagic(stats, "SHADOWRES"))/10
		end,
	},
	BearFrost= {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Bear")
			return (EffectiveHealthMagic(t, "FROSTRES")-EffectiveHealthMagic(stats, "FROSTRES"))/10
		end,
	},
	BearDPS = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Bear")
			return (CalcBearDPS(t)-CalcBearDPS(stats))
		end,
	},
	BearMTG = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Bear")
			return (CalcTP(t)-CalcTP(stats))/10
		end,
	},
	CatDDC = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Cat")
			return 1000*(log(CalcTP(t)*CalcCatDPS(t))-log(CalcTP(stats)*CalcCatDPS(stats)))
		end,
	},
	CatArcane = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Cat")
			return 1000*(log(EffectiveHealthMagic(t,"ARCANERES")*CalcCatDPS(t))-log(EffectiveHealthMagic(stats,"ARCANERES")*CalcCatDPS(stats)))
		end,
	},
	CatFire = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Cat")
			return 1000*(log(EffectiveHealthMagic(t,"FIRERES")*CalcCatDPS(t))-log(EffectiveHealthMagic(stats,"FIRERES")*CalcCatDPS(stats)))
		end,
	},
	CatFrost = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Cat")
			return 1000*(log(EffectiveHealthMagic(t,"FROSTRES")*CalcCatDPS(t))-log(EffectiveHealthMagic(stats,"FROSTRES")*CalcCatDPS(stats)))
		end,
	},
	CatShadow = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Cat")
			return 1000*(log(EffectiveHealthMagic(t,"SHADOWRES")*CalcCatDPS(t))-log(EffectiveHealthMagic(stats,"SHADOWRES")*CalcCatDPS(stats)))
		end,
	},
	CatNature = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Cat")
			return 1000*(log(EffectiveHealthMagic(t,"NATURERES")*CalcCatDPS(t))-log(EffectiveHealthMagic(stats,"NATURERES")*CalcCatDPS(stats)))
		end,
	},
	BearDDC = {
		compare = function(self, stats, equippedBonuses, itemBonuses)
			local t = CatPoints:CalculateStatChanges(stats, equippedBonuses, itemBonuses, "Bear")
			return 1000*(log(CalcBearDPS(t)*CalcTP(t))-log(CalcBearDPS(stats)*CalcTP(stats)))
		end,
	},
}



local invType = {
INVTYPE_HEAD=1,
INVTYPE_NECK=2,
INVTYPE_SHOULDER=3,
INVTYPE_BODY=4,
INVTYPE_CHEST=5,
INVTYPE_WAIST=6,
INVTYPE_LEGS=7,
INVTYPE_FEET=8,
INVTYPE_WRIST=9,
INVTYPE_HAND=10,
INVTYPE_FINGER=11,
INVTYPE_TRINKET=13,
INVTYPE_CLOAK=15,
INVTYPE_WEAPON=16,
INVTYPE_2HWEAPON=16,
INVTYPE_WEAPONMAINHAND=16,
INVTYPE_HOLDABLE=17,
}


local itemCache =
{
	link = nil,
	eqlink =nil,
	lines = {},
}

local  Points = {

	CatDPS = true,
	BearDPS = false,
	BearMTG = true,
	CatMTG = false,
	CatDDC = true,
	BearDDC = false,
	BearNature = false,
	BearFire = false,
	BearH = false,
	BearArcane = false,
	BearFrost = false,
	BearShadow = false,
	CatArcane = false,
	CatFire = false,
	CatShadow = false,
	CatNature = false,
}


local function AddPointsLine(frame, caption, bonuses, add)
	local total
	if(type(bonuses) == "number") then
		if(bonuses > 0) then
			total = "|cff00ff00"..string.format("%.2f", bonuses).."|r"
		elseif (bonuses < 0) then
			total = "|cffff0000"..string.format("%.2f", bonuses).."|r"
		end
	else
		total = tostring(bonuses)
	end

	if(total) then
		frame:AddDoubleLine(caption, total,1,1,1,1,1,1)
		if(add) then
			tinsert(itemCache.lines, {caption, total})
		end
	end
end

local inshow = false

local function AddCatPoints(frame, link)

	if(frame and link) then
		local _, _, _, _, _, _, _, _,itemEquipLoc  = GetItemInfo(link)
		if(itemEquipLoc and invType[itemEquipLoc]) then
			itemEquipLoc = invType[itemEquipLoc]
			local equippedLink = BareID(GetInventoryItemLink("player",itemEquipLoc))
			if(equippedLink and equippedLink ~= link) then
				if(itemCache.eqlink ~= equippedLink or itemCache.link ~= link) then
					itemCache.eqlink = equippedLink
					itemCache.link = link
					itemCache.lines = {}
					local bonuses  = bonus:ScanItem(link, true) or {}
					local equippedBonuses = bonus:ScanItem(equippedLink, true) or {}

					for k,v in pairs(Points) do
						if(v and Modifiers[k]) then
							local config = GetStats(k)
							AddPointsLine(frame, k, Modifiers[k]:compare(config, equippedBonuses,bonuses), true)
						end
					end
				else
					for _,v in ipairs(itemCache.lines) do
						AddPointsLine(frame, v[1], v[2])
					end
				end
			end
		end
		frame:Show()
	end
end





function CatPoints:OnInitialize()

	Options.__index = Options

end

function CatPoints:OnEnable(first)

	if(first) then

		 self:SecureHook(GameTooltip, "SetBagItem", function(this, bag, slot)
					CatPointsDoTooltip(GameTooltip, GetContainerItemLink(bag, slot));
		    end
		  );

		  self:SecureHook(GameTooltip, "SetLootItem", function(this, slot)
					CatPointsDoTooltip(GameTooltip, GetLootSlotLink(slot));
		    end
		  );

		  self:SecureHook(GameTooltip, "SetQuestItem", function(this, unit, slot)
					CatPointsDoTooltip(GameTooltip, GetQuestItemLink(unit, slot));
		    end
		  );

		  self:SecureHook(GameTooltip, "SetQuestLogItem", function(this, sOpt, slot)
					CatPointsDoTooltip(GameTooltip, GetQuestLogItemLink(sOpt, slot));
		    end
		  );

		  self:SecureHook(GameTooltip, "SetTradeSkillItem", function(this, skill, slot)
					local link = (slot) and GetTradeSkillReagentItemLink(skill, slot) or GetTradeSkillItemLink(skill);
					CatPointsDoTooltip(GameTooltip, link);
		    end
		  );

		  self:SecureHook(GameTooltip, "SetMerchantItem", function(this, slot)
					CatPointsDoTooltip(GameTooltip, GetMerchantItemLink(slot));
		    end
		  );

		  self:SecureHook(GameTooltip, "SetAuctionItem", function(this, unit, slot)
					CatPointsDoTooltip(GameTooltip, GetAuctionItemLink(unit, slot));
		    end
		  );

		  self:SecureHook(GameTooltip, "SetLootRollItem", function(this, id)
					CatPointsDoTooltip(GameTooltip, GetLootRollItemLink(id));
		    end
		  );

		  self:Hook(GameTooltip, "SetInventoryItem", function(this, unit, slot)
					local sItem, sCooldown, sRepair = self.hooks[GameTooltip]["SetInventoryItem"](this, unit, slot);
					if(not sItem) then return nil; end
					if (slot > 39) then -- bank
						CatPointsDoTooltip(GameTooltip, GetInventoryItemLink(unit, slot));
					end
					return sItem, sCooldown, sRepair;
		    end
		  , true);

		  self:SecureHook("SetItemRef", function(link, name, button)
					if(link and name and ItemRefTooltip) then
		        if( strsub(link, 1, 6) ~= "Player" ) then
		          if( ItemRefTooltip:IsVisible()) then
		            if(not DressUpFrame:IsVisible()) then
		              CatPointsDoTooltip(ItemRefTooltip, link);
		            end
		            ItemRefTooltip.isDisplayDone = nil;
		          end
		        end
		      end
		    end
  );



	end

end
function CatPointsDoTooltip(frame, link)
	link = BareID(link)
	AddCatPoints(frame, link)
end

local options = {
	type = 'group',
	args = {
		equiv = {
			name = 'equiv',
			type = 'execute',
			desc = "Print equivalence values",
			func = Equivalence
		}
	}
}

CatPoints:RegisterChatCommand("/catpoints", "/cp", options)
